///////////////////////////////////////////////////////////////////////////////
//Standard-Map mit Möglichkeit zum zoomen und einzelne Trajektorien zu erzeugen
//Gewählte Darstellung: Torus  SxS
////////////////////////////////////////////////////////////////////////////////

//Bildausschnitt zu Beginn: (Benötigt kein double, da einmalig)
float xU = 0; float xO = 2*PI;
float yU = -PI  ; float yO = PI;
 

//Zwischenspeicher:
double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
double   xH, yH; 
PFont font;
float w = 800; float h = 800; 
float xK, yK; //Koordinaten der Punkte
int n, i, l, L, M; //Erläuterung im setup()
int f; //für die Farbe
double K;
float faktor;
boolean zeichnen, trajektZeichnen, schonTransparent, gezoomt;
PImage bild;
///////////////////////////////////////////////////////////////////////////


void setup(){ 
   size(800, 800);
  background(0); 
  fill(255);
  smooth();
  textSize(16);
  K = 0.971635; //erster Parameter der Map: Rotationszahl ist goldener Schnitt
  //K = 0.7;
  //K = 0.45;
  //K=1.4;
  //K=2.5;
  //K=3.5;
  //K=4.9976;
  text("K = "+K, 20, 20);
  n= 10000;  //n...Anzahl der Iterationen
  L =100; //L Zufallsstartpunkte
  l = 0; //zählt die Zufallspunkte
  M = 100000; //Anzahl der Punkte auf einer ausgewählten Trajektorie
  xUNeu = xU; xONeu = xO;
  yUNeu = yU; yONeu = yO;
  faktor =1;
     println("K = "+K,"xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
//  AchsenZeichnen(); 
  zeichnen = true;
  trajektZeichnen = false;
  schonTransparent = false;
  gezoomt = false;
  bild = createImage(width,height,RGB);
  strokeWeight(1);
}
 
 void draw(){//Maps mit variierendem Parameter K zeichnen
   if(zeichnen){
     //zufällige Startpunkte aus dem angezeigten Ausschnitt  
     xH =random((float)xUNeu,(float)xONeu);    
     yH = random((float)yUNeu,(float)yONeu); //println(xH,yH);
     iteriere(xH,yH,n,K); 
     if(l<L){
      l++;  
     }
     if(l>=L && !trajektZeichnen){
     
       zeichnen = false;        //println("War hier");
      // tint(255,120);//aktiviert:Bild wird teiltransparent, um die Trajektoerie besser zu sehen
     } 
   }  
 }
//Aus gegebenem Startpunkt (xH,yH) die folgenden n Punkte berechnen
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N ,double K){  
  colorMode(HSB,256,256,256); 
  i=0;
  this.K =K;
  xAlt = (float)xH; 
  yAlt = (float)yH;
  point(xK,yK); 
  n =   N;
  stroke(color(f%256,255,255));
    
  while(i <=n){  
       yNeu = (yAlt + K*Math.sin(xAlt)); 
       xNeu = (xAlt + yNeu) % (2*Math.PI); 
       if(xNeu <0) xNeu = 2*Math.PI+xNeu;//damit  xNeu > 0
       yK = round( map((float)yNeu,yU,yO,h,0));                 
       xK = round (map((float)xNeu,xU,xO,0,w)); 
      
       //obere Seite mit unterer Seite identifizieren (Torus!)       
       if(yK >h && !gezoomt) yK = yK-h; //nur solange nicht gezoomt wird
       if(yK <0 && !gezoomt) yK = h+yK; 
    
       point(xK,yK); 
       xAlt = xNeu;
       yAlt = yNeu;
       i++; 
  }
   i=0;  f++;  
}

void AchsenZeichnen(){
  stroke(255,100); 
  line(0,h/2,w,h/2);
  line(w/2,0,w/2,h);
}


void mousePressed() { 
  //////////////////////////////////////////////////////////
  //Trajektorie zeichnen
  //////////////////////////////////////////////////////////
  if(mouseButton == LEFT){
      trajektZeichnen = true;
      if(!schonTransparent){
        image(bild,0,0);  
        schonTransparent = true;//println("war hier");
      }   
      xH = map(mouseX,0,w,xU,xO); 
      yH = map(mouseY,0,h, yO,yU);
      f = f +19;
      iteriere(xH,yH,M,K);
      M = M + 2000;
  }
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
  if(mouseButton == RIGHT){
      trajektZeichnen = false;
      gezoomt = true;
      background(0);
      faktor = faktor*1;
      xUNeu = map(mouseX,0,w,xU,xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,w,xU,xO)+(xO-xU)/10;
      yUNeu = map(mouseY,0,h, yO,yU)-(yO-yU)/10;
      yONeu = map(mouseY,0,h, yO,yU)+(yO-yU)/10;
      ///////////////////////////////////////////////temp
      double xK = map(mouseX,0,w,xU,xO);
      double yK = map(mouseY,0,h, yO,yU);
      println("Koordinaten: "+xK, yK);
      
      /////////////////////////////////////////////
      xU =(float) xUNeu; xO =(float) xONeu; yU = (float)yUNeu; yO = (float)yONeu;
      println("xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
      l=0;
      n = 2*n;
      zeichnen = true;   
  }
  
}
